#include <WiFi101.h>

// wifi settings
char ssid[] = "ssid-name";
char pass[] = "ssid-password";

// api server enpoint
char server[] = "192.168.6.22";
int port = 5000;

// api key that must be the same as the one in Python code
String api_key = "JtF2aUE5SGHfVJBCG5SH";

// frequency data is sent in ms - every 5 seconds
int timeout = 1000 * 5;

int status = WL_IDLE_STATUS;

void setup() {

	// initialize serial and wait for port to open:
	Serial.begin(9600);
	delay(1000);

	// check for the presence of the shield
	if (WiFi.status() == WL_NO_SHIELD) {
		Serial.println("WiFi shield not present");
		while (true);
	}

	// attempt to connect to wifi network
	while (status != WL_CONNECTED) {
		Serial.print("Attempting to connect to SSID: ");
		Serial.println(ssid);
		status = WiFi.begin(ssid, pass);
		// wait 10 seconds for connection
		delay(10000);
	}

	// output wifi status to serial monitor
	Serial.print("SSID: ");
	Serial.println(WiFi.SSID());

	IPAddress ip = WiFi.localIP();
	Serial.print("IP Address: ");
	Serial.println(ip);

	long rssi = WiFi.RSSI();
	Serial.print("signal strength (RSSI):");
	Serial.print(rssi);
	Serial.println(" dBm");
}

void loop() {

	WiFiClient client;

	if (client.connect(server, port)) {

		// I use random number generator for this example
		// but you can use analog or digital inputs from arduino
		String content = String(random(1000));

		client.println("POST /api HTTP/1.1");
		client.println("Connection: close");
		client.println("Api-Key: " + api_key);
		client.println("Content-Length: " + String(content.length()));
		client.println();
		client.println(content);

		delay(100);
		client.stop();
		Serial.println("Data sent successfully ...");

	} else {
		Serial.println("Problem sending data ...");
	}

	// waits for x seconds and continue looping
	delay(timeout);

}
